from PyQt6.QtWidgets import (
    QApplication,
    QMainWindow,
    QMenu,
    QProxyStyle,
    QStyleOptionMenuItem
)
from PyQt6.QtGui import QFontMetrics
from PyQt6.QtCore import QRect

# -------
class Style(QProxyStyle):
    def __init__(self, style=None):
        super().__init__(style)

    def drawItemText(self, painter, rect, flags, palette, enabled, text, textRole):
        option = QStyleOptionMenuItem()
        option.initFrom(self.parent())
        option.text = ""
        super().drawItemText(painter, rect, flags, palette, enabled, option.text, textRole)

        font_metrics = QFontMetrics(option.font)
        text_width = font_metrics.horizontalAdvance(text)
        text_rect = QRect(
            rect.x() + rect.width() - text_width - 5,
            rect.y(),
            text_width,
            rect.height()
        )
        painter.drawText(text_rect, flags, text)

# -------
class MainWindow(QMainWindow):
    def __init__(self):
        super().__init__()

        file_menu = QMenu("File", self)
        file_menu.addAction("New")
        file_menu.addAction("Open")
        file_menu.addAction("Transform")

        file_menu.setStyle(Style())
        self.menuBar().addMenu(file_menu)

# -------
if __name__ == '__main__':
    app = QApplication([])
    main_window = MainWindow()
    main_window.show()
    app.exec()
